#include <string.h>

static char *strtok_pos;

char *nexttok(void)
{
    return strtok_pos;
}

char *strtok(register char *s, const char *delim)
{
    register char *s1, *s2;

    if (s == NULL) {
        s = strtok_pos;
        if (s == NULL)
            return (char *) NULL;
    }

    s1 = s + strspn(s, delim);
    if (*s1 == '\0') {
        strtok_pos = NULL;
        return (char *) NULL;
    }

    s2 = strpbrk(s1, delim);
    if (s2 != NULL) {
        *s2++ = '\0';
        s2 = s2 + strspn(s2, delim);
    }

    strtok_pos = s2;
    return s1;
}
